<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="userId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'avatarUrl'">
              <a-avatar
                :size="36"
                :src="`${record.avatarUrl}`"
                style="margin-right: 4px"
              >
                <template #icon>
                  <UserOutlined />
                </template>
              </a-avatar>
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 1" color="green">启用</a-tag>
              <a-tag v-if="record.status === 2" color="red">禁用</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a>积分充值</a>
                <a-divider type="vertical" />
                <a>分配特殊卡</a>
                <!--                <a-popconfirm-->
                <!--                  title="确定要删除此记录吗？"-->
                <!--                  @confirm="remove(record)"-->
                <!--                >-->
                <!--                  <a class="ele-text-danger">删除</a>-->
                <!--                </a-popconfirm>-->
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <UserEdit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import {
    ExclamationCircleOutlined,
    UserOutlined
  } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import UserEdit from './components/userEdit.vue';
  import { pageUsers, removeBatchUsers, removeUsers } from '@/api/shop/users';
  import type { Users, UsersParam } from '@/api/shop/users/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Users[]>([]);
  // 当前编辑数据
  const current = ref<Users | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageUsers({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      dataIndex: 'userId',
      key: 'userId',
      width: 90
    },
    {
      title: '头像',
      dataIndex: 'avatarUrl',
      key: 'avatarUrl',
      align: 'center'
    },
    {
      title: '用户名',
      dataIndex: 'username',
      key: 'username',
      align: 'center'
    },
    {
      title: '手机号码',
      dataIndex: 'phone',
      key: 'phone',
      align: 'center'
    },
    {
      title: '性别',
      dataIndex: 'sexName',
      key: 'sexName',
      align: 'center'
    },
    {
      title: '国家',
      dataIndex: 'country',
      key: 'country',
      align: 'center',
      hideInTable: true
    },
    {
      title: '省份',
      dataIndex: 'province',
      key: 'province',
      align: 'center'
    },
    {
      title: '城市',
      dataIndex: 'city',
      key: 'city',
      align: 'center'
    },
    {
      title: '所在辖区',
      dataIndex: 'region',
      key: 'region',
      align: 'center',
      hideInTable: true
    },
    {
      title: '邮箱是否验证, 0否, 1是',
      dataIndex: 'emailVerified',
      key: 'emailVerified',
      align: 'center',
      hideInTable: true
    },
    {
      title: '积分',
      dataIndex: 'points',
      key: 'points',
      sorter: true,
      align: 'center'
    },
    {
      title: '余额',
      dataIndex: 'balance',
      key: 'balance',
      sorter: true,
      align: 'center'
    },
    {
      title: '状态',
      dataIndex: 'status',
      key: 'status',
      align: 'center'
    },
    {
      title: '注册时间',
      dataIndex: 'addTime',
      key: 'addTime',
      align: 'center',
      sorter: true,
      ellipsis: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd')
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: UsersParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Users) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: Users) => {
    const hide = message.loading('请求中..', 0);
    removeUsers(row.userId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchUsers(selection.value.map((d) => d.userId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: Users) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'Users'
  };
</script>

<style lang="less" scoped></style>
